 /*  Name: 
  *  PennKey: 
  *  Recitation: 
  *
  *  A class that represents the bird projectile in
  *  Irate Avians. Can update its own position based
  *  on velocity and time, and can compute whether
  *  it overlaps a given Target.
  *
  */

public class Bird {
	// The position, velocity, and radius members of the bird.
	private double xPos, yPos, xVel, yVel, radius;

	/**
	 * How many more times the player can throw the bird
	 * before losing the game.
	 */
	private int numThrowsRemaining;
	
	/**
	 * Initialize the bird's member variables
	 * with the same names as the inputs to those values.
	 * Initializes the bird's velocity components to 0.
	 */
	public Bird(double xPos, double yPos, double radius, int numThrows) {
		// TODO
	}

	/**
	 * Draws a circle centered at the bird's position
	 * with a radius equal to the bird's radius.
	 * Additionally, draws a triangular beak and two
	 * circular eyes somewhere on the circle to make
	 * the bird look more like a bird. Additional details
	 * are up to your discretion.
	 * Also draws the bird's remaining throws 0.1 units
	 * above its circular body.
	 */
	public void draw() {
		// TODO
	}
	
	/**
	 * Draw the line representing the bird's initial velocity
	 * when the player is clicking and dragging the mouse.
	 */
	public void drawVelocity() {
		// TODO
	}

	/**
	 * Set xPos and yPos to 1.0,
	 * set xVel and yVel to 0.0,
	 * and clear the list of targets hit this launch.
	 */
	public void reset() {
		xPos = yPos = 1.0;
		xVel = yVel = 0.0;
	}

	/**
	 * Compute the bird's initial velocity as the
	 * vector from the mouse's current position to
	 * the bird's current position. This will be used
	 * in mouse listening mode to update the launch
	 * velocity.
	 */
	public void setVelocityFromMousePos() {
		// TODO
	}
	
	/**
	 * Given the change in time, compute the bird's
	 * new position and new velocity.
	 */
	public void update(double timeStep) {
		// TODO
	}

	/**
	 * A helper function used to find the distance
	 * between two 2D points. Remember to use the
	 * Pythagorean Theorem.
	 */
	private static double distance(double x1, double y1, double x2, double y2) {
		// TODO
		return 0.0;
	}

	/**
	 * Given a Target, determine if the bird should
	 * test for collision against it. If the bird
	 * *should* see if it collides with the target,
	 * then perform that test. If the bird collides,
	 * then decrease the target's HP by 1 and add
	 * the target to the bird's list of targets hit
	 * during this launch.
	 */
	public void testAndHandleCollision(Target t) {
		// TODO
	}
	
	// Reduce numThrowsRemaining by 1.
	public void decrementThrows() {
		// TODO
	}
	
	/**
	 * Getter functions that return a copy
	 * of the indicated member variable.
	 */
	public double getXpos() { 
		return xPos; 
	}
	public double getYpos() { 
		return yPos; 
	}
	public double getRadius() { 
		return radius; 
	}
	public int getNumThrowsRemaining() { 
		return numThrowsRemaining; 
	}
}
